# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_coreonly 1

# If you want only core modules to be built, 
# give rpmbuild option '--with coreonly'

%define with_coreonly %{?_with_coreonly:1}%{!?_with_coreonly:0}
%define without_coreonly %{!?_with_coreonly:1}%{?_with_coreonly:0}

%define full_name	jakarta-struts
%define tomcat5appsdir  %{_localstatedir}/lib/tomcat5/webapps
%define tomcat5ctxdir   %{_sysconfdir}/tomcat5/Catalina/localhost
%define webapps		blank documentation example examples tiles-documentation
%define webapplibs commons-beanutils commons-digester commons-fileupload commons-validator oro struts
%define section		free

# Disable check-buildroot
%define __arch_install_post /usr/lib/rpm/check-rpaths 

Name:		struts12
Version:	1.2.9
Release:	%mkrel 11
Epoch:		0
Summary:	Web application framework
License:	ASL 2.0
Group:          Development/Java
Source0:	struts-%{version}-src-RHCLEAN.tar.gz
Source2:	tomcat4-context-allowlinking.xml
Source3:	tomcat5-context-allowlinking.xml
#Patch0:	%{name}-%{version}.build.patch
Patch0:		struts-1.2.9-strutsel-build_xml.patch
Patch1:		struts-1.2.9-FacesRequestProcessor.patch
Patch2:		struts-1.2.9-HttpServletRequestWrapper.patch
Patch3:		struts-1.2.9-FacesTilesRequestProcessor.patch
Patch4:		struts-1.2.9-strutsfaces-example1-build_xml.patch
Patch5:		struts-1.2.9-strutsfaces-example2-build_xml.patch
Patch6:		struts-1.2.9-strutsfaces-systest1-build_xml.patch
Patch7:		struts-1.2.9.bz157205.patch
Patch8:		struts-1.2.9-CVE-2008-2025.patch
Url:		http://struts.apache.org/
Requires:	servletapi5
Requires:	jdbc-stdext
Requires:	jakarta-commons-beanutils
Requires:	jakarta-commons-digester
Requires:	jakarta-commons-fileupload
Requires:	jakarta-commons-validator
Requires:	oro
BuildRequires:	jpackage-utils >= 1.6
BuildRequires:	ant >= 1.6
BuildRequires:  java-rpmbuild
BuildRequires:	antlr
BuildRequires:	ant-trax
BuildRequires:	ant-nodeps
BuildRequires:	jaxp_transform_impl
BuildRequires:	sed
BuildRequires:	servletapi5
BuildRequires:	jdbc-stdext
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-fileupload
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-validator
BuildRequires:  oro
BuildRequires:	tomcat5

%if %{without_coreonly}
BuildRequires:	aspectj
BuildRequires:	httpunit
BuildRequires:	junit
BuildRequires:	jakarta-cactus >= 0:1.7.1-2jpp
BuildRequires:	jakarta-commons-chain
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	jakarta-commons-lang
BuildRequires:	jakarta-commons-pool
BuildRequires:	jakarta-taglibs-standard
BuildRequires:	jtidy
BuildRequires:	log4j
BuildRequires:	myfaces
BuildRequires:	xalan-j2
%endif

BuildArch:	noarch

%description
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on various
servlet and JSP related mailing lists.
Struts includes the following primary areas of functionality:
A controller servlet that dispatches requests to appropriate Action
classes provided by the application developer.
JSP custom tag libraries, and associated support in the controller
servlet, that assists developers in creating interactive form-based
applications.
Utility classes to support XML parsing, automatic population of
JavaBeans properties based on the Java reflection APIs, and
internationalization of prompts and messages.
Struts is part of the Jakarta Project, sponsored by the Apache Software
Foundation. The official Struts home page is at
http://jakarta.apache.org/struts.

%package manual
Summary:        Manual for %{name}
Group:          Development/Java

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java
# for /bin/rm and /bin/ln
Requires(post):   coreutils
Requires(postun): coreutils

%description javadoc
Javadoc for %{name}.

%package webapps-tomcat5
Summary:        Sample %{name} webapps for tomcat5
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       jakarta-commons-beanutils
Requires:       jakarta-commons-digester
Requires:       jakarta-commons-fileupload
Requires:       jakarta-commons-validator
Requires:       oro
Requires:       tomcat5
Requires(post): %{name} = %{version}-%{release}
Requires(post): jakarta-commons-beanutils
Requires(post): jakarta-commons-digester
Requires(post): jakarta-commons-fileupload
Requires(post): jakarta-commons-validator
Requires(post): oro
Requires(post): tomcat5
Requires(pre):  tomcat5
# for /bin/ln and /bin/rm
Requires(post): coreutils
Requires(preun): coreutils

%description webapps-tomcat5
Sample %{name} webapps for tomcat5.

%if %{without_coreonly}
%package chain
Summary:        The %{name} Chain Of Responsibility Adapter
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       jakarta-commons-chain

%description chain
%{summary}.

%package chain-javadoc
Summary:        Javadoc for %{name}-chain
Group:          Development/Java
# for /bin/rm and /bin/ln
Requires(post):   coreutils
Requires(postun): coreutils

%description chain-javadoc
%{summary}.

%package chain-webapps-tomcat5
Summary:        Sample %{name} chain adapter webapps for tomcat5
Group:          Development/Java
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-chain = %{version}-%{release}
Requires:         tomcat5
Requires:         jakarta-commons-chain
Requires(post):   %{name}-chain = %{version}-%{release}
Requires(post):   tomcat5
Requires(pre):    tomcat5
Requires(post):   jakarta-commons-chain
# for /bin/rm
Requires(preun):  coreutils

%description chain-webapps-tomcat5
%{summary}.
%endif

%if %{without_coreonly}
%package el
Summary:        The %{name} EL extension
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:         jakarta-taglibs-standard

%description el
This subproject is an extension of the Struts tag library.
Each JSP custom tag in this library is a subclass of an 
associated tag in the Struts tag library. One difference is 
that this tag library does not use "rtexprvalues", it uses
the expression evaluation engine in the Jakarta Taglibs 
implementation of the JSP Standard Tag Library (version 1.0) 
to evaluate attribute values.

%package el-javadoc
Summary:        Javadoc for %{name}-el
Group:          Development/Java
# for /bin/rm and /bin/ln
Requires(post):   coreutils
Requires(postun): coreutils

%description el-javadoc
%{summary}.

%package el-webapps-tomcat5
Summary:        Sample %{name} EL extension webapps for tomcat5
Group:          Development/Java
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-el = %{version}-%{release}
Requires:         tomcat5
Requires:         jakarta-taglibs-standard
Requires(post):   %{name} = %{version}-%{release}
Requires(post):   %{name}-el = %{version}-%{release}
Requires(post):   tomcat5
Requires(pre):    tomcat5
Requires(post):   jakarta-taglibs-standard
# for /bin/rm
Requires(preun):  coreutils

%description el-webapps-tomcat5
%{summary}.
%endif

%if %{without_coreonly}
%package faces
Summary:        The %{name}-faces integration library
Group:          Development/Java
Requires:       %{name} = %{version}-%{release}
Requires:       myfaces

%description faces
This package contains an add-on library that supports the 
use of JavaServer Faces (JSF) user interface technology in a 
Struts based web application, in place of the Struts custom 
tag libraries.  As a proof of concept, it also includes the 
canonical "struts-example" example web application, converted 
to use JSF tags, as well as tags from the JSP Standard Tag 
Library (JSTL), version 1.0 or later.  It also includes
a very basic Tiles based application, modified in a similar 
manner.

%package faces-javadoc
Summary:        Javadoc for %{name}-faces
Group:          Development/Documentation
# for /bin/rm and /bin/ln
Requires(post):   coreutils
Requires(postun): coreutils

%description faces-javadoc
%{summary}.

%package faces-webapps-tomcat5
Summary:        Sample %{name}-faces integration webapps for tomcat5
Group:          Development/Java
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-faces = %{version}-%{release}
Requires:         jakarta-commons-beanutils
Requires:         jakarta-commons-collections
Requires:         jakarta-commons-digester
Requires:         jakarta-commons-fileupload
Requires:         jakarta-commons-logging
Requires:         jakarta-commons-validator
Requires:         myfaces
Requires:         oro
Requires:         tomcat5
Requires(post):   %{name} = %{version}-%{release}
Requires(post):   %{name}-faces = %{version}-%{release}
Requires(post):   jakarta-commons-beanutils
Requires(post):   jakarta-commons-collections
Requires(post):   jakarta-commons-digester
Requires(post):   jakarta-commons-fileupload
Requires(post):   jakarta-commons-logging
Requires(post):   jakarta-commons-validator
Requires(post):   myfaces
Requires(post):   oro
Requires(post):   tomcat5
Requires(pre):    tomcat5
# for /bin/rm
Requires(preun):  coreutils

%description faces-webapps-tomcat5
%{summary}.
%endif


%prep
rm -rf $RPM_BUILD_ROOT
%setup -n struts-%{version}-src -q
%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -p1 -b .sav
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;

%build
mkdir -p lib
ln -sf $(build-classpath tomcat5-jsp-2.0-api) lib
# build struts
export CLASSPATH=
export ANT_OPTS="-Xmx256m"
STRUTS_BUILD_HOME=$(pwd)
ant  \
	-Dcommons-beanutils.jar=$(build-classpath commons-beanutils) \
	-Dcommons-digester.jar=$(build-classpath commons-digester) \
	-Dcommons-fileupload.jar=$(build-classpath commons-fileupload) \
	-Dcommons-logging.jar=$(build-classpath commons-logging) \
	-Dcommons-validator.jar=$(build-classpath commons-validator) \
	-Djakarta-oro.jar=$(build-classpath oro) \
        -Djdbc20ext.jar=$(find-jar jdbc-stdext) \
	-Djsp.jar=$(build-classpath tomcat5-jsp-2.0-api) \
	-Dservlet.jar=$(build-classpath servletapi5) \
	-Dantlr.jar=$(build-classpath antlr) \
	 dist
#	 compile.library compile.webapps compile.javadoc
# -Dlibdir=/usr/share/java
%if %{without_coreonly}
pushd contrib/struts-chain
export CLASSPATH=$(build-classpath catalina-ant5)
ant -Dlibdir=/usr/share/java \
	-Dcommons-chain.jar=$(build-classpath commons-chain) \
	-Djsp.jar=$(build-classpath tomcat5-jsp-2.0-api) \
	-Dservlet.jar=$(build-classpath servletapi5) \
	-Dstruts.core.home=$STRUTS_BUILD_HOME \
	 dist
popd
%endif

%if %{without_coreonly}
pushd contrib/struts-el
ant -Dlibdir=/usr/share/java \
	-Dstruts.jar=$STRUTS_BUILD_HOME/dist/lib/struts.jar \
	-Djstl.jar=$(build-classpath taglibs-core) \
	-Djstl-standard.jar=$(build-classpath taglibs-standard) \
	-Dservlet.jar=$(build-classpath servletapi5) \
        -Djdbc20ext.jar=$(find-jar jdbc-stdext) \
	-Dcommons-beanutils.jar=$(build-classpath commons-beanutils) \
	-Dcommons-collections.jar=$(build-classpath commons-collections) \
	-Dcommons-digester.jar=$(build-classpath commons-digester) \
	-Dcommons-logging.jar=$(build-classpath commons-logging) \
	-Dcommons-pool.jar=$(build-classpath commons-pool) \
	-Dcommons-validator.jar=$(build-classpath commons-validator) \
	-Djakarta-oro.jar=$(build-classpath oro) \
	-Djsp.jar=$(build-classpath tomcat5-jsp-2.0-api) \
	-Dlog4j.jar=$(build-classpath log4j) \
	-Daspectjrt.jar=$(build-classpath aspectjrt) \
	-Dcactus.jar=$(build-classpath cactus-14/cactus) \
	-Dcactus-ant.jar=$(build-classpath cactus-14/cactus-ant) \
	-Djunit.jar=$(build-classpath junit) \
	-Dhttpunit.jar=$(build-classpath httpunit) \
	-Djtidy.jar=$(build-classpath jtidy) \
	-Dcommons-httpclient.jar=$(build-classpath commons-httpclient) \
	-Dxalanj.jar=$(build-classpath xalan-j2) \
	compile.library compile.webapps compile.javadoc compile.website dist
popd
%endif

%if %{without_coreonly}
pushd contrib/struts-faces
export CLASSPATH=$(build-classpath catalina-ant5):../../dist/lib/struts.jar
ant -Dlibdir=/usr/share/java \
	-Dcommons-beanutils.jar=$(build-classpath commons-beanutils) \
	-Dcommons-collections.jar=$(build-classpath commons-collections) \
	-Dcommons-digester.jar=$(build-classpath commons-digester) \
	-Dcommons-fileupload.jar=$(build-classpath commons-fileupload) \
	-Dcommons-lang.jar=$(build-classpath commons-lang) \
	-Dcommons-logging.jar=$(build-classpath commons-logging) \
	-Dcommons-validator.jar=$(build-classpath commons-validator) \
	-Djakarta-oro.jar=$(build-classpath oro) \
	-Djsf-api.jar=$(build-classpath myfaces/myfaces-jsf-api) \
	-Djsf-impl.jar=$(build-classpath myfaces/myfaces-impl) \
	-Djstl.jar=$(build-classpath taglibs-core) \
	-Dstandard.jar=$(build-classpath taglibs-standard) \
	-Djsp-api.jar=$(build-classpath tomcat5-jsp-2.0-api) \
	-Dservlet.jar=$(build-classpath servletapi5) \
	-Dstruts.jar=$STRUTS_BUILD_HOME/dist/lib/struts.jar \
	-Dstruts.home=$STRUTS_BUILD_HOME \
	 dist
popd
%endif

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 dist/lib/struts.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%if %{without_coreonly}
install -m 644 contrib/struts-chain/dist/lib/%{name}-chain.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-chain-%{version}.jar
install -m 644 contrib/struts-el/dist/lib/%{name}-el.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-el-%{version}.jar
install -m 644 contrib/struts-faces/dist/lib/%{name}-faces.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-faces-%{version}.jar
%endif


(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/documentation/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}
rm -rf target/documentation/api

%if %{without_coreonly}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-chain-%{version}
cp -pr contrib/struts-chain/dist/docs/api/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-chain-%{version}
ln -s %{name}-chain-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-chain
rm -rf contrib/struts-chain/dist/docs/api

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-el-%{version}
cp -pr contrib/struts-el/target/documentation/api/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-el-%{version}
ln -s %{name}-el-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-el
rm -rf contrib/struts-el/target/documentation/api

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-faces-%{version}
cp -pr contrib/struts-faces/dist/docs/api/* \
	$RPM_BUILD_ROOT%{_javadocdir}/%{name}-faces-%{version}
ln -s %{name}-faces-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-faces
rm -rf contrib/struts-faces/dist/docs/api
%endif

# data
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/struts
install -m 644 dist/lib/*.tld $RPM_BUILD_ROOT%{_datadir}/struts
install -m 644 dist/lib/*.dtd $RPM_BUILD_ROOT%{_datadir}/struts
install -m 644 dist/lib/vali*.xml $RPM_BUILD_ROOT%{_datadir}/struts

%if %{without_coreonly}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/struts-chain
install -m 644 contrib/struts-chain/dist/webapps/struts-chain.war \
	$RPM_BUILD_ROOT%{_datadir}/struts-chain
install -m 644 contrib/struts-chain/src/conf/chain-config.xml \
	$RPM_BUILD_ROOT%{_datadir}/struts-chain

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/struts-el
install -m 644 contrib/struts-el/dist/webapps/strutsel-exercise-taglib.war \
	$RPM_BUILD_ROOT%{_datadir}/struts-el
install -m 644 contrib/struts-el/dist/lib/*.tld \
	$RPM_BUILD_ROOT%{_datadir}/struts-el

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/struts-faces
install -m 644 contrib/struts-faces/dist/webapps/struts-faces-example1.war \
	$RPM_BUILD_ROOT%{_datadir}/struts-faces
install -m 644 contrib/struts-faces/dist/webapps/struts-faces-example2.war \
	$RPM_BUILD_ROOT%{_datadir}/struts-faces
install -m 644 contrib/struts-faces/dist/lib/struts-faces.tld \
	$RPM_BUILD_ROOT%{_datadir}/struts-faces
%endif

# core docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs
cp -p {INSTALL,LICENSE.txt,NOTICE.txt,README,STATUS.txt} $RPM_BUILD_ROOT%{_docdir}/struts-%{version}
cp -p target/documentation/*.html $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs
cp -p target/documentation/*.gif $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs
cp -pr target/documentation/uml $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs
cp -pr target/documentation/userGuide $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs
cp -pr target/documentation/images $RPM_BUILD_ROOT%{_docdir}/struts-%{version}/docs

%if %{without_coreonly}
# chain docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/struts-chain-%{version}/docs
#cp -pr contrib/struts-chain/dist/docs/* $RPM_BUILD_ROOT%{_docdir}/struts-chain-%{version}/docs
cp -p contrib/struts-chain/{LICENSE.txt,NOTICE.txt,README.txt} $RPM_BUILD_ROOT%{_docdir}/struts-chain-%{version}

# el docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/struts-el-%{version}/docs
cp -pr contrib/struts-el/target/documentation/* $RPM_BUILD_ROOT%{_docdir}/struts-el-%{version}/docs
cp -pr contrib/struts-el/{LICENSE.txt,README.txt} $RPM_BUILD_ROOT%{_docdir}/struts-el-%{version}

# faces docs
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/struts-faces-%{version}/docs
cp -pr contrib/struts-faces/dist/docs/* $RPM_BUILD_ROOT%{_docdir}/struts-faces-%{version}/docs
cp -pr contrib/struts-faces/{LICENSE.txt,NOTICE.txt,README.txt} $RPM_BUILD_ROOT%{_docdir}/struts-faces-%{version}
%endif

# tomcat 5 webapps
install -d -m 755 $RPM_BUILD_ROOT%{tomcat5appsdir}
install -d -m 755 $RPM_BUILD_ROOT%{tomcat5ctxdir}
for webapp in %{webapps}; do
    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat5appsdir}/struts-$webapp
    cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/$webapp/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/struts-$webapp.xml
	# XXX: move to %%post/preun
	rm -f $RPM_BUILD_ROOT%{tomcat5appsdir}/struts-$webapp/WEB-INF/lib/*
    (cd $RPM_BUILD_ROOT%{tomcat5appsdir}/struts-$webapp/WEB-INF \
    && for tld in ../../../../../..%{_datadir}/struts/*.tld; do ln -sf $tld `basename $tld`; done)
done

%if %{without_coreonly}
pushd $RPM_BUILD_ROOT%{tomcat5appsdir}
mkdir struts-chain
pushd struts-chain
%{jar} xf $RPM_BUILD_ROOT%{_datadir}/struts-chain/struts-chain.war
pushd WEB-INF
#for tld in ../../../../../..%{_datadir}/struts-chain/*.tld; do ln -sf $tld `basename $tld`; done
rm -f lib/*
popd
popd
cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/chain/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/struts-chain.xml
mkdir struts-el-exercise-taglib
pushd struts-el-exercise-taglib
%{jar} xf $RPM_BUILD_ROOT%{_datadir}/struts-el/strutsel-exercise-taglib.war
pushd WEB-INF
rm -f lib/*
for tld in ../../../../../..%{_datadir}/struts-el/*.tld; do ln -sf $tld `basename $tld`; done
popd
popd
cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/el-exercise-taglib/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/struts-el-exercise-taglib.xml

mkdir struts-faces-example1
pushd struts-faces-example1
%{jar} xf $RPM_BUILD_ROOT%{_datadir}/struts-faces/struts-faces-example1.war
pushd WEB-INF
rm -f lib/*
for tld in ../../../../../..%{_datadir}/struts-faces/*.tld; do ln -sf $tld `basename $tld`; done
popd
popd
cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/faces-example1/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/struts-faces-example1.xml

mkdir struts-faces-example2
pushd struts-faces-example2
%{jar} xf $RPM_BUILD_ROOT%{_datadir}/struts-faces/struts-faces-example2.war
pushd WEB-INF
rm -f lib/*
for tld in ../../../../../..%{_datadir}/struts-faces/*.tld; do ln -sf $tld `basename $tld`; done
popd
popd
cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/faces-example2/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/struts-faces-example2.xml
popd
#rm $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-chain/%{name}-chain.war
#rm $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-el/%{name}-el-exercise-taglib.war
#rm $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-faces/%{name}-faces-example1.war
#rm $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-faces/%{name}-faces-example2.war
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post webapps-tomcat5
for webapp in %{webapps}; do
build-jar-repository -s -p %{tomcat5appsdir}/%{name}-$webapp/WEB-INF/lib commons-beanutils commons-digester commons-fileupload commons-validator oro
ln -sf %{_javadir}/%{name}.jar %{tomcat5appsdir}/%{name}-$webapp/WEB-INF/lib/struts.jar
done

%preun webapps-tomcat5
for webapp in %{webapps}; do
rm -f %{tomcat5appsdir}/%{name}-$webapp/WEB-INF/lib/*
done

%if %{without_coreonly}
%post webapps-tomcat3
for webapp in %{webapps}; do
build-jar-repository -s -p %{tomcat3appsdir}/%{name}-$webapp/WEB-INF/lib commons-beanutils commons-digester commons-fileupload commons-validator oro
ln -sf %{_javadir}/%{name}.jar %{tomcat3appsdir}/%{name}-$webapp/WEB-INF/lib/struts.jar
done

%preun webapps-tomcat3
for webapp in %{webapps}; do
rm -f %{tomcat3appsdir}/%{name}-$webapp/WEB-INF/lib/*
done

%post chain-webapps-tomcat5
build-jar-repository -s -p %{tomcat5appsdir}/struts-chain/WEB-INF/lib commons-chain
ln -sf %{_javadir}/%{name}-chain.jar %{tomcat5appsdir}/struts-el-exercise-taglib/WEB-INF/lib/struts-chain.jar

%preun chain-webapps-tomcat5
rm -f  %{tomcat5appsdir}/%{name}-chain/WEB-INF/lib/*

%post el-webapps-tomcat5
build-jar-repository -s -p %{tomcat5appsdir}/struts-el-exercise-taglib/WEB-INF/lib taglibs-core taglibs-standard
ln -sf %{_javadir}/%{name}-el.jar %{tomcat5appsdir}/struts-el-exercise-taglib/WEB-INF/lib/struts-el.jar
ln -sf %{_javadir}/%{name}.jar %{tomcat5appsdir}/struts-el-exercise-taglib/WEB-INF/lib/struts.jar

%preun el-webapps-tomcat5
rm -f  %{tomcat5appsdir}/%{name}-el-exercise-taglib/WEB-INF/lib/*

%post faces-webapps-tomcat5
build-jar-repository -s -p %{tomcat5appsdir}/struts-faces-example1/WEB-INF/lib commons-beanutils commons-collections commons-digester commons-fileupload commons-logging commons-validator oro struts-faces struts myfaces/myfaces-all
build-jar-repository -s -p %{tomcat5appsdir}/struts-faces-example2/WEB-INF/lib commons-beanutils commons-collections commons-digester commons-fileupload commons-logging commons-validator oro struts-faces struts myfaces/myfaces-all

%preun faces-webapps-tomcat5
rm -f %{tomcat5appsdir}/struts-faces-example1/WEB-INF/lib/*
rm -f %{tomcat5appsdir}/struts-faces-example2/WEB-INF/lib/*

%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{without_coreonly}
%post chain-javadoc
rm -f %{_javadocdir}/%{name}-chain
ln -s %{name}-chain-%{version} %{_javadocdir}/%{name}-chain

%postun chain-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-chain
fi

%post el-javadoc
rm -f %{_javadocdir}/%{name}-el
ln -s %{name}-el-%{version} %{_javadocdir}/%{name}-el

%postun el-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-el
fi

%post faces-javadoc
rm -f %{_javadocdir}/%{name}-faces
ln -s %{name}-faces-%{version} %{_javadocdir}/%{name}-faces

%postun faces-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-faces
fi
%endif

%files
%defattr(-,root,root)
%dir %{_docdir}/struts-%{version}
%doc %{_docdir}/struts-%{version}/INSTALL
%doc %{_docdir}/struts-%{version}/README
%doc %{_docdir}/struts-%{version}/*.txt
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/struts

%files manual
%defattr(-,root,root)
%dir %{_docdir}/struts-%{version}
%doc %{_docdir}/struts-%{version}/docs

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files webapps-tomcat5
%defattr(-,tomcat,tomcat)
%dir %{tomcat5appsdir}/struts-blank
%{tomcat5appsdir}/struts-blank/*
%dir %{tomcat5appsdir}/struts-documentation
%{tomcat5appsdir}/struts-documentation/*
%dir %{tomcat5appsdir}/struts-example
%{tomcat5appsdir}/struts-example/*
%dir %{tomcat5appsdir}/struts-examples
%{tomcat5appsdir}/struts-examples/*
%dir %{tomcat5appsdir}/struts-tiles-documentation
%{tomcat5appsdir}/struts-tiles-documentation/*
%{tomcat5ctxdir}/struts-blank.xml
%{tomcat5ctxdir}/struts-documentation.xml
%{tomcat5ctxdir}/struts-example.xml
%{tomcat5ctxdir}/struts-examples.xml
%{tomcat5ctxdir}/struts-tiles-documentation.xml

%if %{without_coreonly}
%files chain
%defattr(-,root,root)
%doc %{_docdir}/struts-chain-%{version}
%{_javadir}/%{name}-chain-%{version}.jar
%{_javadir}/%{name}-chain.jar
%{_datadir}/struts-chain

%files chain-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-chain-%{version}
%ghost %{_javadocdir}/%{name}-chain

%files chain-webapps-tomcat5
%defattr(-,tomcat,tomcat)
%dir %{tomcat5appsdir}/struts-chain
%{tomcat5appsdir}/struts-chain/*
%{tomcat5ctxdir}/struts-chain.xml

%files el
%defattr(-,root,root)
%doc %{_docdir}/struts-el-%{version}
%{_javadir}/%{name}-el-%{version}.jar
%{_javadir}/%{name}-el.jar
%{_datadir}/struts-el

%files el-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-el-%{version}
%ghost %{_javadocdir}/%{name}-el

%files el-webapps-tomcat5
%defattr(-,tomcat,tomcat)
%dir %{tomcat5appsdir}/struts-el-exercise-taglib
%{tomcat5appsdir}/struts-el-exercise-taglib/*
%{tomcat5ctxdir}/struts-el-exercise-taglib.xml

%files faces
%defattr(-,root,root)
%doc %{_docdir}/struts-faces-%{version}
%{_javadir}/%{name}-faces-%{version}.jar
%{_javadir}/%{name}-faces.jar
%{_datadir}/struts-faces

%files faces-javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-faces-%{version}
%ghost %{_javadocdir}/%{name}-faces

%files faces-webapps-tomcat5
%defattr(-,tomcat,tomcat)
%dir %{tomcat5appsdir}/struts-faces-example1
%{tomcat5appsdir}/struts-faces-example1/*
%{tomcat5ctxdir}/struts-faces-example1.xml
%dir %{tomcat5appsdir}/struts-faces-example2
%{tomcat5appsdir}/struts-faces-example2/*
%{tomcat5ctxdir}/struts-faces-example2.xml
%endif



%changelog

* Wed Sep 14 2011 gil <gil> 0:1.2.9-11.mga2
+ Revision: 143489
- imported package struts12

